Index: drivers/video/aty/atyfb_base.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/aty/atyfb_base.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/aty/atyfb_base.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/aty/atyfb_base.c	4 Aug 2004 01:29:59 -0000	1.2
@@ -1516,117 +1728,117 @@
  */
 static int aty_power_mgmt_LT(int sleep, struct fb_info_aty *info)
 {
- 	unsigned int pm;
-	int timeout;
-	
-	pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
-	pm = (pm & ~PWR_MGT_MODE_MASK) | PWR_MGT_MODE_REG;
-	aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
-	pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
-	
-	timeout = 200000;
-	if (sleep) {
-		/* Sleep */
-		pm &= ~PWR_MGT_ON;
-		aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
-		pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
-		udelay(10);
-		pm &= ~(PWR_BLON | AUTO_PWR_UP);
-		pm |= SUSPEND_NOW;
-		aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
-		pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
-		udelay(10);
-		pm |= PWR_MGT_ON;
-		aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
-		do {
-			pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
-			udelay(10);
-			if ((--timeout) == 0)
-				break;
-		} while ((pm & PWR_MGT_STATUS_MASK) != PWR_MGT_STATUS_SUSPEND);
-	} else {
-		/* Wakeup */
-		pm &= ~PWR_MGT_ON;
-		aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
-		pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
-		udelay(10);
-		pm |=  (PWR_BLON | AUTO_PWR_UP);
-		pm &= ~SUSPEND_NOW;
-		aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
-		pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
-		udelay(10);
-		pm |= PWR_MGT_ON;
-		aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
-		do {
-			pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
-			udelay(10);
-			if ((--timeout) == 0)
-				break;
-		} while ((pm & PWR_MGT_STATUS_MASK) != 0);
-	}
-	mdelay(500);
+        unsigned int pm;
+        int timeout;
+        
+        pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
+        pm = (pm & ~PWR_MGT_MODE_MASK) | PWR_MGT_MODE_REG;
+        aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
+        pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
+        
+        timeout = 200000;
+        if (sleep) {
+                /* Sleep */
+                pm &= ~PWR_MGT_ON;
+                aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
+                pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
+                udelay(10);
+                pm &= ~(PWR_BLON | AUTO_PWR_UP);
+                pm |= SUSPEND_NOW;
+                aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
+                pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
+                udelay(10);
+                pm |= PWR_MGT_ON;
+                aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
+                do {
+                        pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
+                        udelay(10);
+                        if ((--timeout) == 0)
+                                break;
+                } while ((pm & PWR_MGT_STATUS_MASK) != PWR_MGT_STATUS_SUSPEND);
+        } else {
+                /* Wakeup */
+                pm &= ~PWR_MGT_ON;
+                aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
+                pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
+                udelay(10);
+                pm |=  (PWR_BLON | AUTO_PWR_UP);
+                pm &= ~SUSPEND_NOW;
+                aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
+                pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
+                udelay(10);
+                pm |= PWR_MGT_ON;
+                aty_st_le32(POWER_MANAGEMENT_LG, pm, info);
+                do {
+                        pm = aty_ld_le32(POWER_MANAGEMENT_LG, info);
+                        udelay(10);
+                        if ((--timeout) == 0)
+                                break;
+                } while ((pm & PWR_MGT_STATUS_MASK) != 0);
+        }
+        mdelay(500);
 
-	return timeout ? PBOOK_SLEEP_OK : PBOOK_SLEEP_REFUSE;
+        return timeout ? PBOOK_SLEEP_OK : PBOOK_SLEEP_REFUSE;
 }
 
 static int aty_power_mgmt_LTPro(int sleep, struct fb_info_aty *info)
 {
- 	unsigned int pm;
-	int timeout;
-	
-	pm = aty_ld_lcd(POWER_MANAGEMENT, info);
-	pm = (pm & ~PWR_MGT_MODE_MASK) | PWR_MGT_MODE_REG;
-	aty_st_lcd(POWER_MANAGEMENT, pm, info);
-	pm = aty_ld_lcd(POWER_MANAGEMENT, info);
-
-	timeout = 200;
-	if (sleep) {
-		/* Sleep */
-		pm &= ~PWR_MGT_ON;
-		aty_st_lcd(POWER_MANAGEMENT, pm, info);
-		pm = aty_ld_lcd(POWER_MANAGEMENT, info);
-		udelay(10);
-		pm &= ~(PWR_BLON | AUTO_PWR_UP);
-		pm |= SUSPEND_NOW;
-		aty_st_lcd(POWER_MANAGEMENT, pm, info);
-		pm = aty_ld_lcd(POWER_MANAGEMENT, info);
-		udelay(10);
-		pm |= PWR_MGT_ON;
-		aty_st_lcd(POWER_MANAGEMENT, pm, info);
-		do {
-			pm = aty_ld_lcd(POWER_MANAGEMENT, info);
-			mdelay(1);
-			if ((--timeout) == 0)
-				break;
-		} while ((pm & PWR_MGT_STATUS_MASK) != PWR_MGT_STATUS_SUSPEND);
-	} else {
-		/* Wakeup */
-		pm &= ~PWR_MGT_ON;
-		aty_st_lcd(POWER_MANAGEMENT, pm, info);
-		pm = aty_ld_lcd(POWER_MANAGEMENT, info);
-		udelay(10);
-		pm &= ~SUSPEND_NOW;
-		pm |= (PWR_BLON | AUTO_PWR_UP);
-		aty_st_lcd(POWER_MANAGEMENT, pm, info);
-		pm = aty_ld_lcd(POWER_MANAGEMENT, info);
-		udelay(10);
-		pm |= PWR_MGT_ON;
-		aty_st_lcd(POWER_MANAGEMENT, pm, info);
-		do {
-			pm = aty_ld_lcd(POWER_MANAGEMENT, info);			
-			mdelay(1);
-			if ((--timeout) == 0)
-				break;
-		} while ((pm & PWR_MGT_STATUS_MASK) != 0);
-	}
+        unsigned int pm;
+        int timeout;
+        
+        pm = aty_ld_lcd(POWER_MANAGEMENT, info);
+        pm = (pm & ~PWR_MGT_MODE_MASK) | PWR_MGT_MODE_REG;
+        aty_st_lcd(POWER_MANAGEMENT, pm, info);
+        pm = aty_ld_lcd(POWER_MANAGEMENT, info);
+
+        timeout = 200;
+        if (sleep) {
+                /* Sleep */
+                pm &= ~PWR_MGT_ON;
+                aty_st_lcd(POWER_MANAGEMENT, pm, info);
+                pm = aty_ld_lcd(POWER_MANAGEMENT, info);
+                udelay(10);
+                pm &= ~(PWR_BLON | AUTO_PWR_UP);
+                pm |= SUSPEND_NOW;
+                aty_st_lcd(POWER_MANAGEMENT, pm, info);
+                pm = aty_ld_lcd(POWER_MANAGEMENT, info);
+                udelay(10);
+                pm |= PWR_MGT_ON;
+                aty_st_lcd(POWER_MANAGEMENT, pm, info);
+                do {
+                        pm = aty_ld_lcd(POWER_MANAGEMENT, info);
+                        mdelay(1);
+                        if ((--timeout) == 0)
+                                break;
+                } while ((pm & PWR_MGT_STATUS_MASK) != PWR_MGT_STATUS_SUSPEND);
+        } else {
+                /* Wakeup */
+                pm &= ~PWR_MGT_ON;
+                aty_st_lcd(POWER_MANAGEMENT, pm, info);
+                pm = aty_ld_lcd(POWER_MANAGEMENT, info);
+                udelay(10);
+                pm &= ~SUSPEND_NOW;
+                pm |= (PWR_BLON | AUTO_PWR_UP);
+                aty_st_lcd(POWER_MANAGEMENT, pm, info);
+                pm = aty_ld_lcd(POWER_MANAGEMENT, info);
+                udelay(10);
+                pm |= PWR_MGT_ON;
+                aty_st_lcd(POWER_MANAGEMENT, pm, info);
+                do {
+                        pm = aty_ld_lcd(POWER_MANAGEMENT, info);                        
+                        mdelay(1);
+                        if ((--timeout) == 0)
+                                break;
+                } while ((pm & PWR_MGT_STATUS_MASK) != 0);
+        }
 
-	return timeout ? PBOOK_SLEEP_OK : PBOOK_SLEEP_REFUSE;
+        return timeout ? PBOOK_SLEEP_OK : PBOOK_SLEEP_REFUSE;
 }
 
 static int aty_power_mgmt(int sleep, struct fb_info_aty *info)
 {
     return M64_HAS(LT_SLEEP) ? aty_power_mgmt_LT(sleep, info)
-			     : aty_power_mgmt_LTPro(sleep, info);
+                             : aty_power_mgmt_LTPro(sleep, info);
 }
 
 /*
@@ -1635,72 +1847,72 @@
  */
 static int aty_sleep_notify(struct pmu_sleep_notifier *self, int when)
 {
-	struct fb_info_aty *info;
- 	int result;
+        struct fb_info_aty *info;
+        int result;
 
-	result = PBOOK_SLEEP_OK;
+        result = PBOOK_SLEEP_OK;
 
-	for (info = first_display; info != NULL; info = info->next) {
-		struct fb_fix_screeninfo fix;
-		int nb;
-
-		atyfb_get_fix(&fix, fg_console, (struct fb_info *)info);
-		nb = fb_display[fg_console].var.yres * fix.line_length;
-
-		switch (when) {
-		case PBOOK_SLEEP_REQUEST:
-			info->save_framebuffer = vmalloc(nb);
-			if (info->save_framebuffer == NULL)
-				return PBOOK_SLEEP_REFUSE;
-			break;
-		case PBOOK_SLEEP_REJECT:
-			if (info->save_framebuffer) {
-				vfree(info->save_framebuffer);
-				info->save_framebuffer = 0;
-			}
-			break;
-		case PBOOK_SLEEP_NOW:
-			if (currcon >= 0)
-				fb_display[currcon].dispsw = &fbcon_dummy;
-			if (info->blitter_may_be_busy)
-				wait_for_idle(info);
-			/* Stop accel engine (stop bus mastering) */
-			if (info->current_par.accel_flags & FB_ACCELF_TEXT)
-				aty_reset_engine(info);
-
-			/* Backup fb content */	
-			if (info->save_framebuffer)
-				memcpy_fromio(info->save_framebuffer,
-				       (void *)info->frame_buffer, nb);
-
-			/* Blank display and LCD */
-			atyfbcon_blank(VESA_POWERDOWN+1, (struct fb_info *)info);
-
-			/* Set chip to "suspend" mode */
-			result = aty_power_mgmt(1, info);
-			break;
-		case PBOOK_WAKE:
-			/* Wakeup chip */
-			result = aty_power_mgmt(0, info);
-
-			/* Restore fb content */			
-			if (info->save_framebuffer) {
-				memcpy_toio((void *)info->frame_buffer,
-				       info->save_framebuffer, nb);
-				vfree(info->save_framebuffer);
-				info->save_framebuffer = 0;
-			}
-			/* Restore display */
-			if (currcon >= 0) {
-				atyfb_set_dispsw(&fb_display[currcon],
-					info, info->current_par.crtc.bpp,
-					info->current_par.accel_flags & FB_ACCELF_TEXT);
-			}
-			atyfbcon_blank(0, (struct fb_info *)info);
-			break;
-		}
-	}
-	return result;
+        for (info = first_display; info != NULL; info = info->next) {
+                struct fb_fix_screeninfo fix;
+                int nb;
+
+                atyfb_get_fix(&fix, fg_console, (struct fb_info *)info);
+                nb = fb_display[fg_console].var.yres * fix.line_length;
+
+                switch (when) {
+                case PBOOK_SLEEP_REQUEST:
+                        info->save_framebuffer = vmalloc(nb);
+                        if (info->save_framebuffer == NULL)
+                                return PBOOK_SLEEP_REFUSE;
+                        break;
+                case PBOOK_SLEEP_REJECT:
+                        if (info->save_framebuffer) {
+                                vfree(info->save_framebuffer);
+                                info->save_framebuffer = 0;
+                        }
+                        break;
+                case PBOOK_SLEEP_NOW:
+                        if (currcon >= 0)
+                                fb_display[currcon].dispsw = &fbcon_dummy;
+                        if (info->blitter_may_be_busy)
+                                wait_for_idle(info);
+                        /* Stop accel engine (stop bus mastering) */
+                        if (info->current_par.accel_flags & FB_ACCELF_TEXT)
+                                aty_reset_engine(info);
+
+                        /* Backup fb content */ 
+                        if (info->save_framebuffer)
+                                memcpy_fromio(info->save_framebuffer,
+                                       (void *)info->frame_buffer, nb);
+
+                        /* Blank display and LCD */
+                        atyfbcon_blank(VESA_POWERDOWN+1, (struct fb_info *)info);
+
+                        /* Set chip to "suspend" mode */
+                        result = aty_power_mgmt(1, info);
+                        break;
+                case PBOOK_WAKE:
+                        /* Wakeup chip */
+                        result = aty_power_mgmt(0, info);
+
+                        /* Restore fb content */                        
+                        if (info->save_framebuffer) {
+                                memcpy_toio((void *)info->frame_buffer,
+                                       info->save_framebuffer, nb);
+                                vfree(info->save_framebuffer);
+                                info->save_framebuffer = 0;
+                        }
+                        /* Restore display */
+                        if (currcon >= 0) {
+                                atyfb_set_dispsw(&fb_display[currcon],
+                                        info, info->current_par.crtc.bpp,
+                                        info->current_par.accel_flags & FB_ACCELF_TEXT);
+                        }
+                        atyfbcon_blank(0, (struct fb_info *)info);
+                        break;
+                }
+        }
+        return result;
 }
 
 static struct pmu_sleep_notifier aty_sleep_notifier = {
@@ -1715,38 +1927,38 @@
      */
 
 static int backlight_conv[] = {
-	0x00, 0x3f, 0x4c, 0x59, 0x66, 0x73, 0x80, 0x8d,
-	0x9a, 0xa7, 0xb4, 0xc1, 0xcf, 0xdc, 0xe9, 0xff
+        0x00, 0x3f, 0x4c, 0x59, 0x66, 0x73, 0x80, 0x8d,
+        0x9a, 0xa7, 0xb4, 0xc1, 0xcf, 0xdc, 0xe9, 0xff
 };
 
 static int
 aty_set_backlight_enable(int on, int level, void* data)
 {
-	struct fb_info_aty *info = (struct fb_info_aty *)data;
-	unsigned int reg = aty_ld_lcd(LCD_MISC_CNTL, info);
-	
-	reg |= (BLMOD_EN | BIASMOD_EN);
-	if (on && level > BACKLIGHT_OFF) {
-		reg &= ~BIAS_MOD_LEVEL_MASK;
-		reg |= (backlight_conv[level] << BIAS_MOD_LEVEL_SHIFT);
-	} else {
-		reg &= ~BIAS_MOD_LEVEL_MASK;
-		reg |= (backlight_conv[0] << BIAS_MOD_LEVEL_SHIFT);
-	}
-	aty_st_lcd(LCD_MISC_CNTL, reg, info);
+        struct fb_info_aty *info = (struct fb_info_aty *)data;
+        unsigned int reg = aty_ld_lcd(LCD_MISC_CNTL, info);
+        
+        reg |= (BLMOD_EN | BIASMOD_EN);
+        if (on && level > BACKLIGHT_OFF) {
+                reg &= ~BIAS_MOD_LEVEL_MASK;
+                reg |= (backlight_conv[level] << BIAS_MOD_LEVEL_SHIFT);
+        } else {
+                reg &= ~BIAS_MOD_LEVEL_MASK;
+                reg |= (backlight_conv[0] << BIAS_MOD_LEVEL_SHIFT);
+        }
+        aty_st_lcd(LCD_MISC_CNTL, reg, info);
 
-	return 0;
+        return 0;
 }
 
 static int
 aty_set_backlight_level(int level, void* data)
 {
-	return aty_set_backlight_enable(1, level, data);
+        return aty_set_backlight_enable(1, level, data);
 }
 
 static struct backlight_controller aty_backlight_controller = {
-	aty_set_backlight_enable,
-	aty_set_backlight_level
+        aty_set_backlight_enable,
+        aty_set_backlight_level
 };
 #endif /* CONFIG_PMAC_BACKLIGHT */
 
@@ -1768,25 +1980,26 @@
     u16 type;
     u8 rev;
     const char *chipname = NULL, *ramname = NULL, *xtal;
-    int pll, mclk, gtb_memsize;
+    int pll, mclk, xclk, gtb_memsize;
 #if defined(CONFIG_PPC)
     int sense;
 #endif
-    u8 pll_ref_div;
+    u32 monitors_enabled;
 
     info->aty_cmap_regs = (struct aty_cmap_regs *)(info->ati_regbase+0xc0);
     chip_id = aty_ld_le32(CONFIG_CHIP_ID, info);
     type = chip_id & CFG_CHIP_TYPE;
     rev = (chip_id & CFG_CHIP_REV)>>24;
     for (j = 0; j < (sizeof(aty_chips)/sizeof(*aty_chips)); j++)
-	if (type == aty_chips[j].chip_type &&
-	    (rev & aty_chips[j].rev_mask) == aty_chips[j].rev_val) {
-	    chipname = aty_chips[j].name;
-	    pll = aty_chips[j].pll;
-	    mclk = aty_chips[j].mclk;
-	    info->features = aty_chips[j].features;
-	    goto found;
-	}
+        if (type == aty_chips[j].chip_type &&
+            (rev & aty_chips[j].rev_mask) == aty_chips[j].rev_val) {
+            chipname = aty_chips[j].name;
+            pll = aty_chips[j].pll;
+            mclk = aty_chips[j].mclk;
+            xclk = aty_chips[j].xclk;
+            info->features = aty_chips[j].features;
+            goto found;
+        }
     printk("atyfb: Unknown mach64 0x%04x rev 0x%04x\n", type, rev);
     return 0;
 
@@ -1794,208 +2007,258 @@
     printk("atyfb: %s [0x%04x rev 0x%02x] ", chipname, type, rev);
 #ifdef CONFIG_FB_ATY_GX
     if (!M64_HAS(INTEGRATED)) {
-	u32 stat0;
-	u8 dac_type, dac_subtype, clk_type;
-	stat0 = aty_ld_le32(CONFIG_STAT0, info);
-	info->bus_type = (stat0 >> 0) & 0x07;
-	info->ram_type = (stat0 >> 3) & 0x07;
-	ramname = aty_gx_ram[info->ram_type];
-	/* FIXME: clockchip/RAMDAC probing? */
-	dac_type = (aty_ld_le32(DAC_CNTL, info) >> 16) & 0x07;
+        u32 stat0;
+        u8 dac_type, dac_subtype, clk_type;
+        stat0 = aty_ld_le32(CONFIG_STAT0, info);
+        info->bus_type = (stat0 >> 0) & 0x07;
+        info->ram_type = (stat0 >> 3) & 0x07;
+        ramname = aty_gx_ram[info->ram_type];
+        /* FIXME: clockchip/RAMDAC probing? */
+        dac_type = (aty_ld_le32(DAC_CNTL, info) >> 16) & 0x07;
 #ifdef CONFIG_ATARI
-	clk_type = CLK_ATI18818_1;
-	dac_type = (stat0 >> 9) & 0x07;
-	if (dac_type == 0x07)
-	    dac_subtype = DAC_ATT20C408;
-	else
-	    dac_subtype = (aty_ld_8(SCRATCH_REG1 + 1, info) & 0xF0) | dac_type;
+        clk_type = CLK_ATI18818_1;
+        dac_type = (stat0 >> 9) & 0x07;
+        if (dac_type == 0x07)
+            dac_subtype = DAC_ATT20C408;
+        else
+            dac_subtype = (aty_ld_8(SCRATCH_REG1 + 1, info) & 0xF0) | dac_type;
 #else
-	dac_type = DAC_IBMRGB514;
-	dac_subtype = DAC_IBMRGB514;
-	clk_type = CLK_IBMRGB514;
-#endif
-	switch (dac_subtype) {
-	    case DAC_IBMRGB514:
-		info->dac_ops = &aty_dac_ibm514;
-		break;
-	    case DAC_ATI68860_B:
-	    case DAC_ATI68860_C:
-		info->dac_ops = &aty_dac_ati68860b;
-		break;
-	    case DAC_ATT20C408:
-	    case DAC_ATT21C498:
-		info->dac_ops = &aty_dac_att21c498;
-		break;
-	    default:
-		printk(" atyfb_set_par: DAC type not implemented yet!\n");
-		info->dac_ops = &aty_dac_unsupported;
-		break;
-	}
-	switch (clk_type) {
-	    case CLK_ATI18818_1:
-		info->pll_ops = &aty_pll_ati18818_1;
-		break;
-	    case CLK_STG1703:
-		info->pll_ops = &aty_pll_stg1703;
-		break;
-	    case CLK_CH8398:
-		info->pll_ops = &aty_pll_ch8398;
-		break;
-	    case CLK_ATT20C408:
-		info->pll_ops = &aty_pll_att20c408;
-		break;
-	    case CLK_IBMRGB514:
-		info->pll_ops = &aty_pll_ibm514;
-		break;
-	    default:
-		printk(" atyfb_set_par: CLK type not implemented yet!");
-		info->pll_ops = &aty_pll_unsupported;
-		break;
-	}
+        dac_type = DAC_IBMRGB514;
+        dac_subtype = DAC_IBMRGB514;
+        clk_type = CLK_IBMRGB514;
+#endif
+        switch (dac_subtype) {
+            case DAC_IBMRGB514:
+                info->dac_ops = &aty_dac_ibm514;
+                break;
+            case DAC_ATI68860_B:
+            case DAC_ATI68860_C:
+                info->dac_ops = &aty_dac_ati68860b;
+                break;
+            case DAC_ATT20C408:
+            case DAC_ATT21C498:
+                info->dac_ops = &aty_dac_att21c498;
+                break;
+            default:
+                printk(" atyfb_set_par: DAC type not implemented yet!\n");
+                info->dac_ops = &aty_dac_unsupported;
+                break;
+        }
+        switch (clk_type) {
+            case CLK_ATI18818_1:
+                info->pll_ops = &aty_pll_ati18818_1;
+                break;
+            case CLK_STG1703:
+                info->pll_ops = &aty_pll_stg1703;
+                break;
+            case CLK_CH8398:
+                info->pll_ops = &aty_pll_ch8398;
+                break;
+            case CLK_ATT20C408:
+                info->pll_ops = &aty_pll_att20c408;
+                break;
+            case CLK_IBMRGB514:
+                info->pll_ops = &aty_pll_ibm514;
+                break;
+            default:
+                printk(" atyfb_set_par: CLK type not implemented yet!");
+                info->pll_ops = &aty_pll_unsupported;
+                break;
+        }
     }
 #endif /* CONFIG_FB_ATY_GX */
 #ifdef CONFIG_FB_ATY_CT
     if (M64_HAS(INTEGRATED)) {
-	info->bus_type = PCI;
-	info->ram_type = (aty_ld_le32(CONFIG_STAT0, info) & 0x07);
-	ramname = aty_ct_ram[info->ram_type];
-	info->dac_ops = &aty_dac_ct;
-	info->pll_ops = &aty_pll_ct;
-	/* for many chips, the mclk is 67 MHz for SDRAM, 63 MHz otherwise */
-	if (mclk == 67 && info->ram_type < SDRAM)
-	    mclk = 63;
+        info->bus_type = PCI;
+        info->ram_type = (aty_ld_le32(CONFIG_STAT0, info) & 0x07);
+        ramname = aty_ct_ram[info->ram_type];
+        info->dac_ops = &aty_dac_ct;
+        info->pll_ops = &aty_pll_ct;
+#ifdef CONFIG_ALL_PPC
+	/* The Apple iBook1 uses non-standard memory frequencies. We detect it
+	   and set the frequency manually. */
+	if ((type==0x4c4e) && machine_is_compatible("PowerBook2,1")) {
+	    mclk=70;
+	    xclk=53;
+	};
+#endif
+	/*
+	 * I disable the hack below because it is completely unreliable. 
+	 * DRAM at 67 is very well imaginable. If a chip is indeed clocked
+	 * below it's official clock rate because it is equiped with
+	 * too slow memory the driver information table
+	 * in the BIOS will contain the right value. So if you need it
+	 * write code to scan the driver information table, it will work
+	 * in any case the chip is clocked lower than the official rate
+	 * instead of just cases where the mclk is 67 MHz.
+	 * (Daniel Mantione, 25 may 2003)
+	 */
+        /* for many chips, the mclk is 67 MHz for SDRAM, 63 MHz otherwise */
+/*        if (xclk == 67 && info->ram_type < SDRAM)
+             xclk = 63;*/
     }
 #endif /* CONFIG_FB_ATY_CT */
 
     info->ref_clk_per = 1000000000000ULL/14318180;
     xtal = "14.31818";
-    if (M64_HAS(GTB_DSP) && (pll_ref_div = aty_ld_pll(PLL_REF_DIV, info))) {
-	int diff1, diff2;
-	diff1 = 510*14/pll_ref_div-pll;
-	diff2 = 510*29/pll_ref_div-pll;
-	if (diff1 < 0)
-	    diff1 = -diff1;
-	if (diff2 < 0)
-	    diff2 = -diff2;
-	if (diff2 < diff1) {
-	    info->ref_clk_per = 1000000000000ULL/29498928;
-	    xtal = "29.498928";
+#ifdef CONFIG_FB_ATY_CT
+    if (M64_HAS(INTEGRATED)) {
+	u8 pll_ref_div = aty_ld_pll(PLL_REF_DIV, info);
+	if (pll_ref_div) {
+	    int diff1, diff2;
+	    diff1 = 510*14/pll_ref_div-pll;
+	    diff2 = 510*29/pll_ref_div-pll;
+	    if (diff1 < 0)
+		diff1 = -diff1;
+	    if (diff2 < 0)
+		diff2 = -diff2;
+	    if (diff2 < diff1) {
+		info->ref_clk_per = 1000000000000ULL/29498928;
+		xtal = "29.498928";
+	    }
 	}
     }
+#endif /* CONFIG_FB_ATY_CT */
 
     i = aty_ld_le32(MEM_CNTL, info);
     gtb_memsize = M64_HAS(GTB_DSP);
     if (gtb_memsize)
-	switch (i & 0xF) {	/* 0xF used instead of MEM_SIZE_ALIAS */
-	    case MEM_SIZE_512K:
-		info->total_vram = 0x80000;
-		break;
-	    case MEM_SIZE_1M:
-		info->total_vram = 0x100000;
-		break;
-	    case MEM_SIZE_2M_GTB:
-		info->total_vram = 0x200000;
-		break;
-	    case MEM_SIZE_4M_GTB:
-		info->total_vram = 0x400000;
-		break;
-	    case MEM_SIZE_6M_GTB:
-		info->total_vram = 0x600000;
-		break;
-	    case MEM_SIZE_8M_GTB:
-		info->total_vram = 0x800000;
-		break;
-	    default:
-		info->total_vram = 0x80000;
-	}
+        switch (i & 0xF) {      /* 0xF used instead of MEM_SIZE_ALIAS */
+            case MEM_SIZE_512K:
+                info->total_vram = 0x80000;
+                break;
+            case MEM_SIZE_1M:
+                info->total_vram = 0x100000;
+                break;
+            case MEM_SIZE_2M_GTB:
+                info->total_vram = 0x200000;
+                break;
+            case MEM_SIZE_4M_GTB:
+                info->total_vram = 0x400000;
+                break;
+            case MEM_SIZE_6M_GTB:
+                info->total_vram = 0x600000;
+                break;
+            case MEM_SIZE_8M_GTB:
+                info->total_vram = 0x800000;
+                break;
+            default:
+                info->total_vram = 0x80000;
+        }
     else
-	switch (i & MEM_SIZE_ALIAS) {
-	    case MEM_SIZE_512K:
-		info->total_vram = 0x80000;
-		break;
-	    case MEM_SIZE_1M:
-		info->total_vram = 0x100000;
-		break;
-	    case MEM_SIZE_2M:
-		info->total_vram = 0x200000;
-		break;
-	    case MEM_SIZE_4M:
-		info->total_vram = 0x400000;
-		break;
-	    case MEM_SIZE_6M:
-		info->total_vram = 0x600000;
-		break;
-	    case MEM_SIZE_8M:
-		info->total_vram = 0x800000;
-		break;
-	    default:
-		info->total_vram = 0x80000;
-	}
+        switch (i & MEM_SIZE_ALIAS) {
+            case MEM_SIZE_512K:
+                info->total_vram = 0x80000;
+                break;
+            case MEM_SIZE_1M:
+                info->total_vram = 0x100000;
+                break;
+            case MEM_SIZE_2M:
+                info->total_vram = 0x200000;
+                break;
+            case MEM_SIZE_4M:
+                info->total_vram = 0x400000;
+                break;
+            case MEM_SIZE_6M:
+                info->total_vram = 0x600000;
+                break;
+            case MEM_SIZE_8M:
+                info->total_vram = 0x800000;
+                break;
+            default:
+                info->total_vram = 0x80000;
+        }
 
     if (M64_HAS(MAGIC_VRAM_SIZE)) {
-	if (aty_ld_le32(CONFIG_STAT1, info) & 0x40000000)
-	  info->total_vram += 0x400000;
+        if (aty_ld_le32(CONFIG_STAT1, info) & 0x40000000)
+          info->total_vram += 0x400000;
     }
 
     if (default_vram) {
-	info->total_vram = default_vram*1024;
-	i = i & ~(gtb_memsize ? 0xF : MEM_SIZE_ALIAS);
-	if (info->total_vram <= 0x80000)
-	    i |= MEM_SIZE_512K;
-	else if (info->total_vram <= 0x100000)
-	    i |= MEM_SIZE_1M;
-	else if (info->total_vram <= 0x200000)
-	    i |= gtb_memsize ? MEM_SIZE_2M_GTB : MEM_SIZE_2M;
-	else if (info->total_vram <= 0x400000)
-	    i |= gtb_memsize ? MEM_SIZE_4M_GTB : MEM_SIZE_4M;
-	else if (info->total_vram <= 0x600000)
-	    i |= gtb_memsize ? MEM_SIZE_6M_GTB : MEM_SIZE_6M;
-	else
-	    i |= gtb_memsize ? MEM_SIZE_8M_GTB : MEM_SIZE_8M;
-	aty_st_le32(MEM_CNTL, i, info);
+        info->total_vram = default_vram*1024;
+        i = i & ~(gtb_memsize ? 0xF : MEM_SIZE_ALIAS);
+        if (info->total_vram <= 0x80000)
+            i |= MEM_SIZE_512K;
+        else if (info->total_vram <= 0x100000)
+            i |= MEM_SIZE_1M;
+        else if (info->total_vram <= 0x200000)
+            i |= gtb_memsize ? MEM_SIZE_2M_GTB : MEM_SIZE_2M;
+        else if (info->total_vram <= 0x400000)
+            i |= gtb_memsize ? MEM_SIZE_4M_GTB : MEM_SIZE_4M;
+        else if (info->total_vram <= 0x600000)
+            i |= gtb_memsize ? MEM_SIZE_6M_GTB : MEM_SIZE_6M;
+        else
+            i |= gtb_memsize ? MEM_SIZE_8M_GTB : MEM_SIZE_8M;
+        aty_st_le32(MEM_CNTL, i, info);
     }
     if (default_pll)
-	pll = default_pll;
+        pll = default_pll;
     if (default_mclk)
-	mclk = default_mclk;
-
-    printk("%d%c %s, %s MHz XTAL, %d MHz PLL, %d Mhz MCLK\n",
-    	   info->total_vram == 0x80000 ? 512 : (info->total_vram >> 20),
-    	   info->total_vram == 0x80000 ? 'K' : 'M', ramname, xtal, pll, mclk);
-
-    if (mclk < 44)
-	info->mem_refresh_rate = 0;	/* 000 = 10 Mhz - 43 Mhz */
-    else if (mclk < 50)
-	info->mem_refresh_rate = 1;	/* 001 = 44 Mhz - 49 Mhz */
-    else if (mclk < 55)
-	info->mem_refresh_rate = 2;	/* 010 = 50 Mhz - 54 Mhz */
-    else if (mclk < 66)
-	info->mem_refresh_rate = 3;	/* 011 = 55 Mhz - 65 Mhz */
-    else if (mclk < 75)
-	info->mem_refresh_rate = 4;	/* 100 = 66 Mhz - 74 Mhz */
-    else if (mclk < 80)
-	info->mem_refresh_rate = 5;	/* 101 = 75 Mhz - 79 Mhz */
-    else if (mclk < 100)
-	info->mem_refresh_rate = 6;	/* 110 = 80 Mhz - 100 Mhz */
+        mclk = default_mclk;
+    if (default_xclk)
+        xclk = default_xclk;
+
+    printk("%d%c %s, %s MHz XTAL, %d MHz PLL, %d Mhz MCLK, %d Mhz XCLK\n",
+           info->total_vram == 0x80000 ? 512 : (info->total_vram >> 20),
+           info->total_vram == 0x80000 ? 'K' : 'M', ramname, xtal, pll, mclk,
+           xclk);
+
+    if (xclk < 44)
+        info->mem_refresh_rate = 0;     /* 000 = 10 Mhz - 43 Mhz */
+    else if (xclk < 50)
+        info->mem_refresh_rate = 1;     /* 001 = 44 Mhz - 49 Mhz */
+    else if (xclk < 55)
+        info->mem_refresh_rate = 2;     /* 010 = 50 Mhz - 54 Mhz */
+    else if (xclk < 66)
+        info->mem_refresh_rate = 3;     /* 011 = 55 Mhz - 65 Mhz */
+    else if (xclk < 75)
+        info->mem_refresh_rate = 4;     /* 100 = 66 Mhz - 74 Mhz */
+    else if (xclk < 80)
+        info->mem_refresh_rate = 5;     /* 101 = 75 Mhz - 79 Mhz */
+    else if (xclk < 100)
+        info->mem_refresh_rate = 6;     /* 110 = 80 Mhz - 100 Mhz */
     else
-	info->mem_refresh_rate = 7;	/* 111 = 100 Mhz and above */
+        info->mem_refresh_rate = 7;     /* 111 = 100 Mhz and above */
     info->pll_per = 1000000/pll;
-    info->mclk_per = 1000000/mclk;
+    if ((mclk < 0) || (xclk < 0)) {
+        info->mclk_per = 0;
+        info->xclk_per = 0;
+    } else {
+        info->mclk_per = 1000000/mclk;
+        info->xclk_per = 1000000/xclk;
+    };
 
 #ifdef DEBUG
     if (M64_HAS(INTEGRATED)) {
-	int i;
-	printk("BUS_CNTL DAC_CNTL MEM_CNTL EXT_MEM_CNTL CRTC_GEN_CNTL "
-	       "DSP_CONFIG DSP_ON_OFF\n"
-	       "%08x %08x %08x %08x     %08x      %08x   %08x\n"
-	       "PLL",
-	       aty_ld_le32(BUS_CNTL, info), aty_ld_le32(DAC_CNTL, info),
-	       aty_ld_le32(MEM_CNTL, info), aty_ld_le32(EXT_MEM_CNTL, info),
-	       aty_ld_le32(CRTC_GEN_CNTL, info), aty_ld_le32(DSP_CONFIG, info),
-	       aty_ld_le32(DSP_ON_OFF, info));
-	for (i = 0; i < 16; i++)
-	    printk(" %02x", aty_ld_pll(i, info));
-	printk("\n");
+        int i;
+        printk("BUS_CNTL DAC_CNTL MEM_CNTL EXT_MEM_CNTL CRTC_GEN_CNTL "
+               "DSP_CONFIG DSP_ON_OFF CLOCK_CNTL\n"
+               "%08x %08x %08x %08x     %08x      %08x   %08x   %08x\n"
+               "PLL",
+               aty_ld_le32(BUS_CNTL, info), aty_ld_le32(DAC_CNTL, info),
+               aty_ld_le32(MEM_CNTL, info), aty_ld_le32(EXT_MEM_CNTL, info),
+               aty_ld_le32(CRTC_GEN_CNTL, info), aty_ld_le32(DSP_CONFIG, info),
+               aty_ld_le32(DSP_ON_OFF, info), aty_ld_le32(CLOCK_CNTL ,info));
+        for (i = 0; i < 40; i++)
+            printk(" %02x", aty_ld_pll(i, info));
+        printk("\n");
+    }
+#endif
+    info->pll_ops->init_pll(info);
+#ifdef DEBUG
+    if (M64_HAS(INTEGRATED)) {
+        int i;
+        printk("BUS_CNTL DAC_CNTL MEM_CNTL EXT_MEM_CNTL CRTC_GEN_CNTL "
+               "DSP_CONFIG DSP_ON_OFF\n"
+               "%08x %08x %08x %08x     %08x      %08x   %08x\n"
+               "PLL",
+               aty_ld_le32(BUS_CNTL, info), aty_ld_le32(DAC_CNTL, info),
+               aty_ld_le32(MEM_CNTL, info), aty_ld_le32(EXT_MEM_CNTL, info),
+               aty_ld_le32(CRTC_GEN_CNTL, info), aty_ld_le32(DSP_CONFIG, info),
+               aty_ld_le32(DSP_ON_OFF, info));
+        for (i = 0; i < 40; i++)
+            printk(" %02x", aty_ld_pll(i, info));
+        printk("\n");
     }
 #endif
 
@@ -2005,8 +2268,8 @@
      *  the full 8 MB of video RAM on 8 MB boards
      */
     if (info->total_vram == 0x800000 ||
-	(info->bus_type == ISA && info->total_vram == 0x400000))
-	    info->total_vram -= GUI_RESERVE;
+        (info->bus_type == ISA && info->total_vram == 0x400000))
+            info->total_vram -= GUI_RESERVE;
 
     /* Clear the video memory */
     fb_memset((void *)info->frame_buffer, 0, info->total_vram);
@@ -2026,12 +2289,12 @@
 
 #ifdef CONFIG_PMAC_BACKLIGHT
     if (M64_HAS(G3_PB_1_1) && machine_is_compatible("PowerBook1,1")) {
-	/* these bits let the 101 powerbook wake up from sleep -- paulus */
-	aty_st_lcd(POWER_MANAGEMENT, aty_ld_lcd(POWER_MANAGEMENT, info)
-		| (USE_F32KHZ | TRISTATE_MEM_EN), info);
+        /* these bits let the 101 powerbook wake up from sleep -- paulus */
+        aty_st_lcd(POWER_MANAGEMENT, aty_ld_lcd(POWER_MANAGEMENT, info)
+                | (USE_F32KHZ | TRISTATE_MEM_EN), info);
     }
     if (M64_HAS(MOBIL_BUS))
-	register_backlight_controller(&aty_backlight_controller, info, "ati");
+        register_backlight_controller(&aty_backlight_controller, info, "ati");
 #endif /* CONFIG_PMAC_BACKLIGHT */
 
 #ifdef MODULE
